<template>
  <article class="view view--identiy-user-email-verification-resend">
    <FancyAlert v-if="sent" type="success">
      <p>
        If an account exists for that username or email address, an email will have been sent with a link to verify it.
      </p>
      <p>
        If your email program doesn't allow you to click on links, you can go to the
        <router-link :to="emailVerificationRoute">email verification page</router-link>
        to enter the code manually.
      </p>
    </FancyAlert>
    <VForm
      v-else
      name="identiy-user-email-verification-resend-form"
      :fields="fields"
      :modelState="modelState"
      buttonText="Send"
      buttonIconClass="bi bi-envelope-fill"
      :busy="sending"
      busyButtonText="Sending..."
      :error="errorDescription"
      @input="onInput"
      @submit="onSubmit"
    />
  </article>
</template>

<script>
import { ref } from 'vue'
import { FancyAlert, VForm, useApi, useNotification } from '../../../core'
import UsersApi from '../../api/users-api.js'

export default {
  name: 'IdentityPublicEmailVerificationResendView',
  components: {
    FancyAlert,
    VForm,
  },
  setup() {
    const api = useApi()
    const notify = useNotification()
    const usersApi = new UsersApi(api)

    const fields = ref([
      {
        type: 'text',
        name: 'usernameOrEmail',
        label: 'Username or email',
        validate: 'required',
        maxlength: 255,
        value: '',
      },
    ])

    const modelState = ref({})
    const errorDescription = ref('')
    const sending = ref(false)
    const sent = ref(false)
    const emailVerificationRoute = { name: 'identity-public-email-verification' }

    const onInput = () => {
      errorDescription.value = ''
    }

    const onSubmit = async (form) => {
      errorDescription.value = ''
      sending.value = true
      sent.value = false

      try {
        await usersApi.resendEmailVerificationAsync(form.usernameOrEmail)
        sent.value = true
      } catch (ex) {
        if (ex.response.data?.modelState) {
          modelState.value = ex.response.data.modelState
        } else if (ex.response.data?.message) {
          errorDescription.value = ex.response.data.message
        } else {
          notify.error('There was a problem with the "resend email verification" system.', ex)
        }
      } finally {
        sending.value = false
      }
    }

    return {
      fields,
      modelState,
      errorDescription,
      sending,
      sent,
      emailVerificationRoute,
      onInput,
      onSubmit,
    }
  },
}
</script>
